package com.adhi.adhij;

import java.io.Serializable;
import java.util.ArrayList;
/**
 * This class forms the core of any business application.  It
 * encapsulates business rules and contains a value object and 
 * a data access object. 
 * @author DKRISHNA
 *
 */
public abstract class BusinessObject implements Serializable
{
	private ValueObject VO;

	private DataAccessObject DAO;

	private DataAccessObject dataAccessObject;

	/**
	 * returns the data access object
	 * @return the data access object
	 */
	public DataAccessObject getDAO() {
		return DAO;
	}

	/**
	 * sets the data access object
	 * @param dao The dAO to set.
	 */
	public void setDAO(DataAccessObject DAO) {
		this.DAO = DAO;
	}

	/**
	 * returns the value object
	 * @return the vO.
	 */
	public ValueObject getVO() {
		return VO;
	}

	/**
	 * sets the value object
	 * @param vo The vO to set.
	 */
	public void setVO(ValueObject VO) {
		this.VO = VO;
	}

	/**
	 * sets the mode on the value objects
	 * @param valueObjects the value objects
	 * @param mode the mode to set
	 */
	public void setMode(ArrayList valueObjects, short mode)
	{
		if(valueObjects != null && valueObjects.size() > 0)
		{
			int size = valueObjects.size();
			ValueObject valueObject = null;
			for(int i=0; i < size; i++)
			{
				valueObject= (ValueObject) valueObjects.get(i);
				valueObject.setMode(mode);
			}
		}
	}

	public DataAccessObject getDataAccessObject() {
		return dataAccessObject;
	}

	public void setDataAccessObject(DataAccessObject dataAccessObject) {
		this.dataAccessObject = dataAccessObject;
	}

};