/*
 * Created on May 20, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package com.adhi.adhij;

import java.util.ArrayList;

/**
 * The Row set class has matrix like representation.  It has rows and columns.
 * Ideal for table like data structure.
 * @author DKRISHNA
 *
 */
public class RowSet extends ArrayList{

	/**
	 * sorting order - ascending
	 */
	public static final int ASCENDING = 1;
	/**
	 * sorting order - descending
	 */
	public static final int DESCENDING = -1;
	
	/**
	 * add a row to this row set
	 * @param row the row
	 */
	public void add(ArrayList row)
	{
		if (row != null)
		{
			super.add(row);
		}
	}
	
	/**
	 * sort the rowset by the column and by the sort type
	 * (ascending or descending order).  The object in the column 
	 * should implement comparable
	 * @param column the column to be sorted by
	 * @param orderType the order of sort (ascending or descending)
	 */
	public void sort(int column, int orderType)
	{
		Object temp = null;
		boolean notDone = false;
		int i=0;
		int size = size();
		ArrayList row1 = null, row2 = null;
		Comparable element1 = null, element2 = null;
		int comparison = -1;
		//bubble sort
		do
		{
			notDone = false;
			for(i=0; i<size-1; i++)
			{
				row1 = (ArrayList)get(i);
				row2 = (ArrayList)get(i+1);
				element1 = (Comparable)row1.get(column);
				element2 = (Comparable)row2.get(column);
				
				if(element1 == null && element2 == null)
				{
					comparison = 0;
				}
				else if(element1 == null)
				{
					//if the element1 is null, assume element1 is less than
					// element2
					comparison = -1*orderType;
				}
				else if(element2 == null)
				{
					//if the element2 is null, assume element2 is less than
					// element2
					comparison = 1*orderType;
				}
				else
				{
					comparison = element1.compareTo(element2)*orderType;
				}

				if( comparison > 0)
				{
					set(i, row2);
					set(i+1, row1);
					notDone = true;
				}					

			}
		
		} while(notDone);
		
	}
	
	/**
	 * sort by the column in ascending order
	 * @param column the column to be sorted by
	 */
	public void sort(int column)
	{
		sort(column, ASCENDING);
	}
	

}
